#ifndef BMX_PLUGIN_H
#define BMX_PLUGIN_H

#define BMX_VERSION "1.15"
#pragma warning(disable : 4800)
#include <extdll.h> // always
#include <meta_api.h> // of course

extern meta_globals_t *gpMetaGlobals; // metamod globals
extern gamedll_funcs_t *gpGamedllFuncs; // gameDLL function tables
extern mutil_funcs_t *gpMetaUtilFuncs; // metamod utility functions
#define HLMOD 0
#define CSTRIKE 1
extern int g_mod_type;

extern cvar_t *bmx_scorelimit;
extern cvar_t *bmx_changelimit;


extern cvar_t *bmx_version;
extern cvar_t *bmx_giveitem;







extern int giveitem;


#define MAX_PLAYERS 32
#define MAX_PLAYER_NAME 128
#define MAX_MODEL_NAME 16
#define MAX_TEAMS 8
#define MAX_TEAM_NAME 16
#define MENU_NONE 0
#define MENU_TK 1
#define MENU_VOTEMAP 2
#define MENU_VOTEKICK 3
#define MSGBEGIN 0
#define MSGEND -1
struct hegrenade_t
{
	int index;
	Vector origin;
	float time;
};
struct tkmenu_t
{
	bool menu;
	int killer;
	int count;
};
struct CurWeapon_t
{
	int id;
	int clip;
};
struct player_extra_info_t
{
	char model[MAX_MODEL_NAME];
	int frags;
	int deaths;
	short playerclass;
	short teamnumber;
	int headshots;
	int teamkills;
	int suicides;
	int attrib;
	char teamname[MAX_TEAM_NAME];
	int ext_frags;//extention_frags
	float time;
	int money;

	/////Added
	int ext_money;
	int battery;
	int ammo[16];
	hegrenade_t hegrenade;
	bool nightvision;
	bool nvgtoggle;
	bool buyzone;
	bool defuser;
	int menustate;
	int damage;
	int damage2enemy;
	CurWeapon_t curweap;
	int primid;
	int secid;
	int chooseteam;
	int last_weapons;
	int armortype;
	float radiotime;
	float last_health;
	int last_team;
	bool bInitHUD;
	int hostagekill;
	tkmenu_t tkmenu;
	int teamwins;
};
float SetTimer(float timeout);
bool IsBot(edict_t *pEdict);
void GiveNamedItem(edict_t *pEdict, const char *pszName);
void UTIL_ShowMenu(edict_t *pEdict, int slots, int displaytime, bool needmore, char *pText);
void FakeClientCommand(edict_t *pEntity, const char *arg1, const char *arg2=NULL, const char *arg3=NULL);
void ClientKill(edict_t *pEntity);
void ClientPrint(edict_t *pEntity, int msg_dest, const char *msg_name, const char *param1=NULL, const char *param2=NULL, const char *param3=NULL, const char *param4=NULL);
bool check_cmd(edict_t *pEntity);
void UTIL_ClearMenu(edict_t *pEntity);
extern player_extra_info_t g_PlayerInfo[MAX_PLAYERS+1];
extern edict_t *listenserver_edict;
extern enginefuncs_t g_engfuncs;
void UTIL_StringToVector(float *pVector, const char *pString);
int UTIL_CountTeam(int team);
bool IsHLTV(edict_t *pEdict);
int CountInfoPlayerStart();
int CountInfoPlayerDeathmatch();
void Restore(edict_t *pEntity);
#define MOVE_NORMAL 0// normal move in the direction monster is facing
#define MOVE_STRAFE 1// moves in direction specified, no matter which way monster is facing
void UTIL_Speak(edict_t *pent, const char *pszSentence);
// Hit Group standards
#define HITGROUP_GENERIC 0
#define HITGROUP_HEAD 1
#define HITGROUP_CHEST 2
#define HITGROUP_STOMACH 3
#define HITGROUP_LEFTARM 4
#define HITGROUP_RIGHTARM 5
#define HITGROUP_LEFTLEG 6
#define HITGROUP_RIGHTLEG 7
extern bool bSpawn;
extern int g_msg_dest;
extern int g_msg_index;
extern int g_msg_type;
extern int g_map_type;
// new util functions...
void UTIL_Pathname_Convert(char *pathname);
void UTIL_TrimWhitespace(char *text);
void UTIL_ReplaceWhitespace(char *text);
//////////////////////////////////////////////////////////////
edict_t *UTIL_FindEntityInSphere(edict_t *pentStart, const Vector &vecCenter, float flRadius);
edict_t *UTIL_FindEntityByString(edict_t *pentStart, const char *szKeyword, const char *szValue);
edict_t *UTIL_FindEntityByClassname(edict_t *pentStart, const char *szName);
edict_t *UTIL_FindEntityByTargetname(edict_t *pentStart, const char *szName);
extern unsigned short FixedUnsigned16(float value, float scale);
extern short FixedSigned16(float value, float scale);
void UTIL_HudMessage(edict_t *pEdict, const hudtextparms_t &textparms, const char *pMessage);
void UTIL_HudMessageAll(const hudtextparms_t &textparms, const char *pMessage);
void UTIL_ClientPrintAll(int msg_dest, const char *msg_name, const char *param1, const char *param2, const char *param3, const char *param4);
void UTIL_SayText(const char *pText, edict_t *pEdict);
void UTIL_SayTextAll(const char *pText, edict_t *pEdict);
void UTIL_SayTextAll(const char *pText);
void UTIL_ShowMessage(const char *pString, edict_t *pEdict);
void UTIL_ShowMessageAll(const char *pString);
BOOL UTIL_IsValidEntity(edict_t *pent);
BOOL IsAlive(edict_t *pEdict);
void cvar_update(void);
bool slap(int index);

void GameDLLInit(void);

#endif // BMX_PLUGIN_H
