#ifndef CSTRIKE_H
#define CSTRIKE_H

#define DEAD 1
#define BOMB 2
#define VIP 4

#define TERRORIST 1
#define CT 2
#define ALL 0
#define NONE -1

#define CS_MAP 1
#define DE_MAP 2
#define AS_MAP 3
#define ES_MAP 4
#define KA_MAP 5
#define PA_MAP 6
#define _MAP 0


extern cvar_t *bmx_score_frags;
extern cvar_t *bmx_score_deaths;
extern cvar_t *bmx_radio_mode;
extern cvar_t *bmx_ext_point;
extern cvar_t *bmx_autojoin;
extern cvar_t *bmx_autobalance;
extern cvar_t *bmx_teamchange;
extern cvar_t *bmx_changetype;
extern cvar_t *bmx_changerounds;
extern cvar_t *bmx_sayunknown;
extern cvar_t *bmx_moneymode;
extern cvar_t *bmx_multiweapons;
extern cvar_t *bmx_roundmoney;
extern cvar_t *bmx_winreward;
extern cvar_t *bmx_loser_money;
extern cvar_t *bmx_elimreward;
extern cvar_t *bmx_vipreward;
extern cvar_t *bmx_escreward;
extern cvar_t *bmx_bombreward;
extern cvar_t *bmx_hosreward;
extern cvar_t *bmx_killenemy;
extern cvar_t *bmx_killmate;
extern cvar_t *bmx_killhostage;
extern cvar_t *bmx_startmoney;
extern cvar_t *bmx_tkslap;
extern cvar_t *bmx_ext_score;
extern cvar_t *bmx_buyrestrict;
extern cvar_t *bmx_showscore;
extern cvar_t *bmx_waittime;
extern cvar_t *bmx_timeupreward;
extern cvar_t *bmx_maxmoney;
extern cvar_t *bmx_viprotation;
extern cvar_t *bmx_team1;
extern cvar_t *bmx_team2;
extern cvar_t *bmx_hkpenalty;


extern cvar_t *bmx_interval;
extern cvar_t *bmx_showround;

extern float mp_buytime;
extern float mp_timelimit;
extern int mp_autoteambalance;
extern int mp_limitteams;

extern int score_frags;
extern int score_deaths;
extern int radio_mode;
extern int ext_point;
extern int autojoin;
extern int autobalance;
extern int teamchange;
extern int changetype;
extern int changerounds;
extern int sayunknown;
extern int moneymode;
extern int multiweapons;
extern int roundmoney;
extern int winreward;
extern int loser_money;
extern int elimreward;
extern int vipreward;
extern int escreward;
extern int bombreward;
extern int killenemy;
extern int killmate;
extern int killhostage;
extern int startmoney;
extern int tkslap;
extern int ext_score;
extern const char* buyrestrict;
extern int showscore;
extern float waittime;
extern int hosreward;
extern int timeupreward;
extern int maxmoney;
extern int viprotation;
extern const char* team1;
extern const char* team2;
extern int hkpenalty;

extern float interval;
extern int showround;

class CPrintMessage{
public:
	CPrintMessage()
	{
		_msg_dst=HUD_PRINTCENTER;
		f_exist=0;
	}
	inline void check()
	{
		if(f_exist==1)
		{
			f_exist=0;
			UTIL_ClientPrintAll(_msg_dst, msg);
			UTIL_ClientPrintAll(HUD_PRINTCONSOLE, msg);
			//HUD_PRINTNOTIFY
			//HUD_PRINTCONSOLE
			//HUD_PRINTTALK
			//HUD_PRINTCENTER
		}
	}
	void set(const char* _msg, int __msg_dst=HUD_PRINTCENTER)
	{
		strcpy(msg, _msg);
		f_exist=1;
		_msg_dst=__msg_dst;
	}
private:
	int f_exist;
	int _msg_dst;
	char msg[100];
};

struct UnknownCmd_t
{
	bool unknown;
	char command[256];
};

struct TeamScore_t
{
	int team1;
	int team2;
	bool changed;
	int lastlose;
	int losecount;
	int ctwins;
};

extern TeamScore_t TeamScore;
extern int round;

void auto_join(edict_t *pEdict);
void auto_balance();
bool team_replace();
bool team_shuffle();
void teamscore(void);
void replaceteamname(void);
void changeteam(void);
void changeteamnext(void);
void UTIL_NVGToggle(edict_t *pEdict);
void UpdateInfo(edict_t *pTarget);
void UpdateScoreInfo(int index);
void UpdateTeamInfo(int index);
void RadioMessageTeam(edict_t *pEdict,const char *msg_name);
int CountHostages();
int CalcTeamMoney(int team, int cost=0);
int CalcMoney(int index, int cost=0);
void CantBuyHere(edict_t *pEntity);
void CantBuyNow(edict_t *pEntity);
void NotEnoughMoney(edict_t *pEntity);
void CantBuyThis(edict_t *pEntity);
void UpdateTeamScore();
void GetMapType();
int ScoreFrag(int i);
int ScoreDeath(int i);
extern int cur_round;
extern hudtextparms_t round_tparms;
extern int g_map_type;
extern int g_map_buying;
extern float halftime;
extern float buytime;
extern float restarttime;
extern bool bTeamChange;
extern int Hostages;
extern bool bTeamScoreUpdate;
extern float intermission;
extern float respawntime;
extern float killtime;

bool team_kill();
bool team_respawn();

extern bool bRespawn;
extern int g_map_buying;
extern int the_vip;
extern int the_plant;
extern int the_defuse;
extern float halftime;
extern float buytime;
extern float killtime;
extern float respawntime;
extern float intermission;
extern float restarttime;
extern int f_firstBlood;
extern CPrintMessage pMSG;
extern bool bTeamChange;
extern Vector hostage_origin;
extern int scoreupdate;
extern int round;
extern TeamScore_t TeamScore;
extern int Hostages;
extern int HosRescued;
extern UnknownCmd_t UnknownCmd;
extern bool bTeamScoreUpdate;

//void CS_PlayerThink(edict_t *pEntity);
void CS_Frame();
void CS_Update();
bool CS_check_cmd(edict_t *pEntity);
void CS_NewRound();
void CS_Round_Restart();
void CS_Round_Start();
void CS_Round_End();
void CS_Game_Commencing();
void CS_Message(ALERT_TYPE atype, char *msg);
bool CS_EmitSound(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch);
void CS_SetModel(edict_t *e, const char *m);
void CS_StartFrame(void);
void CS_KeyValue(edict_t *pentKeyvalue, KeyValueData *pkvd);
void CS_cvar_update(void);

void setprice(void);

#endif
