// vi: set ts=4 sw=4 :
// vim: set tw=75 :
#include <extdll.h>
/*
* Copyright(c)2001 Will Day <willday@hpgx.net>
*
* This file is part of Metamod.
*
* Metamod is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or(at
* your option)any later version.
*
* Metamod is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Metamod; if not, write to the Free Software Foundation,
* Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* In addition, as a special exception, the author gives permission to
* link the code of this program with the Half-Life Game Engine("HL
* Engine")and Modified Game Libraries("MODs")developed by Valve,
* L.L.C("Valve"). You must obey the GNU General Public License in all
* respects for all of the code used other than the HL Engine and MODs
* from Valve. If you modify this file, you may extend this exception
* to your version of the file, but you are not obligated to do so. If
* you do not wish to do so, delete this exception statement from your
* version.
*
*/
#include <dllapi.h>
#include <meta_api.h>
#include "usercmd.h"

#include "enginecallback.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "scriplib.h"
#include "bmx_plugin.h"
#include "cstrike.h"

#include "item.h"
#include "usrmsg.h"
#include "playerbuy.h"
#include "moneymsg.h"

extern globalvars_t *gpGlobals;

cvar_t cvar_bmx_version	=	{"bmx_version",BMX_VERSION, FCVAR_SERVER };
cvar_t cvar_score_frags	=	{"bmx_score_frags","0"};
cvar_t cvar_score_deaths=	{"bmx_score_deaths","0"};
cvar_t cvar_radio_mode	=	{"bmx_radio_mode","0"};
cvar_t cvar_ext_point	=	{"bmx_ext_point","3"};
cvar_t cvar_autojoin	=	{"bmx_autojoin","0"};
cvar_t cvar_autobalance	=	{"bmx_autobalance","0"};
cvar_t cvar_teamchange	=	{"bmx_teamchange","0"};//shuffle replace team
cvar_t cvar_changetype	=	{"bmx_changetype","0"};
cvar_t cvar_changerounds=	{"bmx_changerounds","3"};
cvar_t cvar_sayunknown	=	{"bmx_sayunknown","0"};

cvar_t cvar_moneymode	=	{"bmx_moneymode","0"};
cvar_t cvar_giveitem	=	{"bmx_giveitem","0"};
cvar_t cvar_multiweapons=	{"bmx_multiweapons", "0"};
cvar_t cvar_roundmoney	=	{"bmx_roundmoney","1500"};
cvar_t cvar_winreward	=	{"bmx_winreward","750"};
cvar_t cvar_loser_money	=	{"bmx_loser_money","500"};
cvar_t cvar_elimreward	=	{"bmx_elimreward","2500"};
cvar_t cvar_vipreward	=	{"bmx_vipreward","2750"};
cvar_t cvar_escreward	=	{"bmx_escreward","2750"};
cvar_t cvar_bombreward	=	{"bmx_bombreward","2750"};
cvar_t cvar_hosreward	=	{"bmx_hosreward","1000"};
cvar_t cvar_killenemy	=	{"bmx_killenemy","300"};
cvar_t cvar_killmate	=	{"bmx_killmate","3300"};
cvar_t cvar_killhostage	=	{"bmx_killhostage","1500"};
cvar_t cvar_startmoney	=	{"bmx_startmoney","800"};
//cvar_t cvar_anticheat	=	{"bmx_anticheat","0"};
cvar_t cvar_tkslap		=	{"bmx_tkslap","0"};
cvar_t cvar_ext_score	=	{"bmx_ext_score","0"};
cvar_t cvar_buyrestrict	=	{"bmx_buyrestrict",""};
cvar_t cvar_showscore	=	{"bmx_showscore","0"};

cvar_t cvar_waittime	=	{"bmx_waittime","0.5"};
cvar_t cvar_timeupreward=	{"bmx_timeupreward","1250"};
cvar_t cvar_maxmoney	=	{"bmx_maxmoney","16000"};
cvar_t cvar_viprotation	=	{"bmx_viprotation","0"};
cvar_t cvar_team1		=	{"bmx_team1","team1"};
cvar_t cvar_team2		=	{"bmx_team2","team2"};

cvar_t cvar_hkpenalty	=	{"bmx_hkpenalty","0"};



cvar_t cvar_interval	=	{"bmx_interval","0.1"};

cvar_t cvar_showround	=	{"bmx_showround","0"};



cvar_t cvar_scorelimit	=	{"bmx_scorelimit","0"};
cvar_t cvar_changelimit	=	{"bmx_changelimit","0"};
cvar_t *bmx_scorelimit=NULL;
cvar_t *bmx_changelimit=NULL;


cvar_t *bmx_version=NULL;
cvar_t *bmx_giveitem=NULL;




cvar_t *bmx_score_frags=NULL;
cvar_t *bmx_score_deaths=NULL;
cvar_t *bmx_radio_mode=NULL;
cvar_t *bmx_ext_point=NULL;
cvar_t *bmx_autojoin=NULL;
cvar_t *bmx_autobalance=NULL;
cvar_t *bmx_teamchange=NULL;
cvar_t *bmx_changetype=NULL;
cvar_t *bmx_changerounds=NULL;
cvar_t *bmx_sayunknown=NULL;
cvar_t *bmx_moneymode=NULL;
cvar_t *bmx_multiweapons=NULL;
cvar_t *bmx_roundmoney=NULL;
cvar_t *bmx_winreward=NULL;
cvar_t *bmx_loser_money=NULL;
cvar_t *bmx_elimreward=NULL;
cvar_t *bmx_vipreward=NULL;
cvar_t *bmx_escreward=NULL;
cvar_t *bmx_bombreward=NULL;
cvar_t *bmx_hosreward=NULL;
cvar_t *bmx_killenemy=NULL;
cvar_t *bmx_killmate=NULL;
cvar_t *bmx_killhostage=NULL;
cvar_t *bmx_startmoney=NULL;
cvar_t *bmx_tkslap=NULL;
cvar_t *bmx_ext_score=NULL;
cvar_t *bmx_buyrestrict=NULL;
cvar_t *bmx_showscore=NULL;
cvar_t *bmx_waittime=NULL;
cvar_t *bmx_timeupreward=NULL;
cvar_t *bmx_maxmoney=NULL;
cvar_t *bmx_viprotation=NULL;
cvar_t *bmx_team1=NULL;
cvar_t *bmx_team2=NULL;
cvar_t *bmx_hkpenalty=NULL;

cvar_t *bmx_interval=NULL;
cvar_t *bmx_showround=NULL;

edict_t *listenserver_edict=NULL;


void GameDLLInit(void)
{
	// ALERT(at_console,"GameDLLInit\n");
	CVAR_REGISTER(&cvar_bmx_version);
	CVAR_REGISTER(&cvar_giveitem);




	bmx_version	=	CVAR_GET_POINTER("bmx_version");
	bmx_giveitem	=	CVAR_GET_POINTER("bmx_giveitem");


	if(g_mod_type==CSTRIKE)
	{
		CVAR_REGISTER(&cvar_score_frags);
		CVAR_REGISTER(&cvar_score_deaths);
		CVAR_REGISTER(&cvar_radio_mode);
		CVAR_REGISTER(&cvar_ext_point);
		CVAR_REGISTER(&cvar_autojoin);
		CVAR_REGISTER(&cvar_autobalance);
		CVAR_REGISTER(&cvar_teamchange);
		CVAR_REGISTER(&cvar_changetype);
		CVAR_REGISTER(&cvar_changerounds);
		CVAR_REGISTER(&cvar_sayunknown);
		CVAR_REGISTER(&cvar_moneymode);
		CVAR_REGISTER(&cvar_multiweapons);
		CVAR_REGISTER(&cvar_roundmoney);
		CVAR_REGISTER(&cvar_winreward);
		CVAR_REGISTER(&cvar_loser_money);
		CVAR_REGISTER(&cvar_elimreward);
		CVAR_REGISTER(&cvar_vipreward);
		CVAR_REGISTER(&cvar_escreward);
		CVAR_REGISTER(&cvar_bombreward);
		CVAR_REGISTER(&cvar_hosreward);
		CVAR_REGISTER(&cvar_killenemy);
		CVAR_REGISTER(&cvar_killmate);
		CVAR_REGISTER(&cvar_killhostage);
		CVAR_REGISTER(&cvar_startmoney);
		CVAR_REGISTER(&cvar_tkslap);
		CVAR_REGISTER(&cvar_ext_score);
		CVAR_REGISTER(&cvar_buyrestrict);
		CVAR_REGISTER(&cvar_showscore);
		CVAR_REGISTER(&cvar_waittime);
		CVAR_REGISTER(&cvar_timeupreward);
		CVAR_REGISTER(&cvar_maxmoney);
		CVAR_REGISTER(&cvar_viprotation);
		CVAR_REGISTER(&cvar_team1);
		CVAR_REGISTER(&cvar_team2);
		CVAR_REGISTER(&cvar_hkpenalty);

		CVAR_REGISTER(&cvar_interval);
		CVAR_REGISTER(&cvar_showround);

		CVAR_REGISTER(&cvar_scorelimit);
		CVAR_REGISTER(&cvar_changelimit);
		
		bmx_scorelimit	=	CVAR_GET_POINTER("bmx_scorelimit");
		bmx_changelimit	=	CVAR_GET_POINTER("bmx_changelimit");

		bmx_score_frags	=	CVAR_GET_POINTER("bmx_score_frags");
		bmx_score_deaths=	CVAR_GET_POINTER("bmx_score_deaths");
		bmx_radio_mode	=	CVAR_GET_POINTER("bmx_radio_mode");
		bmx_ext_point	=	CVAR_GET_POINTER("bmx_ext_point");
		bmx_autojoin	=	CVAR_GET_POINTER("bmx_autojoin");
		bmx_autobalance	=	CVAR_GET_POINTER("bmx_autobalance");
		bmx_teamchange	=	CVAR_GET_POINTER("bmx_teamchange");
		bmx_changetype	=	CVAR_GET_POINTER("bmx_changetype");
		bmx_changerounds=	CVAR_GET_POINTER("bmx_changerounds");
		bmx_sayunknown	=	CVAR_GET_POINTER("bmx_sayunknown");
		bmx_moneymode	=	CVAR_GET_POINTER("bmx_moneymode");
		bmx_multiweapons=	CVAR_GET_POINTER("bmx_multiweapons");
		bmx_roundmoney	=	CVAR_GET_POINTER("bmx_roundmoney");
		bmx_winreward	=	CVAR_GET_POINTER("bmx_winreward");
		bmx_loser_money	=	CVAR_GET_POINTER("bmx_loser_money");
		bmx_elimreward	=	CVAR_GET_POINTER("bmx_elimreward");
		bmx_vipreward	=	CVAR_GET_POINTER("bmx_vipreward");
		bmx_escreward	=	CVAR_GET_POINTER("bmx_escreward");
		bmx_bombreward	=	CVAR_GET_POINTER("bmx_bombreward");
		bmx_hosreward	=	CVAR_GET_POINTER("bmx_hosreward");
		bmx_killenemy	=	CVAR_GET_POINTER("bmx_killenemy");
		bmx_killmate	=	CVAR_GET_POINTER("bmx_killmate");
		bmx_killhostage	=	CVAR_GET_POINTER("bmx_killhostage");
		bmx_startmoney	=	CVAR_GET_POINTER("bmx_startmoney");
		bmx_tkslap		=	CVAR_GET_POINTER("bmx_tkslap");
		bmx_ext_score	=	CVAR_GET_POINTER("bmx_ext_score");
		bmx_buyrestrict	=	CVAR_GET_POINTER("bmx_buyrestrict");
		bmx_showscore	=	CVAR_GET_POINTER("bmx_showscore");
		bmx_waittime	=	CVAR_GET_POINTER("bmx_waittime");
		bmx_timeupreward=	CVAR_GET_POINTER("bmx_timeupreward");
		bmx_maxmoney	=	CVAR_GET_POINTER("bmx_maxmoney");
		bmx_viprotation	=	CVAR_GET_POINTER("bmx_viprotation");
		bmx_team1		=	CVAR_GET_POINTER("bmx_team1");
		bmx_team2		=	CVAR_GET_POINTER("bmx_team2");
		bmx_hkpenalty	=	CVAR_GET_POINTER("bmx_hkpenalty");

		bmx_interval	=	CVAR_GET_POINTER("bmx_interval");
		bmx_showround	=	CVAR_GET_POINTER("bmx_showround");


		REG_SVR_COMMAND("bmx_teamscore",teamscore);
		REG_SVR_COMMAND("bmx_replaceteamname",replaceteamname);
		REG_SVR_COMMAND("bmx_changeteam",changeteam);
		REG_SVR_COMMAND("bmx_changeteamnext",changeteamnext);
		REG_SVR_COMMAND("bmx_setprice",setprice);
	}
	REG_SVR_COMMAND("bmx_cvarupdate",cvar_update);
	RETURN_META(MRES_IGNORED);
}
/*int DispatchSpawn(edict_t *pent)
{

	char *pClassname=(char *)STRING(pent->v.classname);
	// ALERT(at_console,"DispatchSpawn %s\n",pClassname);
	if(strcmp(pClassname, "worldspawn")==0)
	{
		// do level initialization stuff here...

	}

	RETURN_META_VALUE(MRES_IGNORED, META_RESULT_PREVIOUS);
}*/
void DispatchKeyValue(edict_t *pentKeyvalue, KeyValueData *pkvd)
{
	// ALERT(at_console,"DispatchKeyValue %s %s\n",pkvd->szKeyName,pkvd->szValue);
	if(pkvd&&pkvd->szValue)
	{
		if(strcmp(pkvd->szValue,"worldspawn")==0)
		{
			bSpawn=true;
			g_map_type=_MAP;
			g_map_buying=0;
		}
		else if(g_mod_type==CSTRIKE)
		{
			CS_KeyValue(pentKeyvalue, pkvd);
		}
	}
	RETURN_META(MRES_IGNORED);
}
BOOL ClientConnect(edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ])
{
	// ALERT(at_console,"ClientConnect\n");
	if(strcmp(pszAddress, "loopback")==0)
	{
		// save the edict of the listen server client...
		listenserver_edict=pEntity;
	}
	if(g_mod_type==CSTRIKE&&changetype!=0&&!IsHLTV(pEntity))
	{
		edict_t *pEdict=NULL;
		int count=2;
		for(int x=1; x<=gpGlobals->maxClients; x++)
		{
			pEdict=INDEXENT(x);
			if(!UTIL_IsValidEntity(pEdict))
				continue;
			if(!IsHLTV(pEdict))count++;
		}
		int info_player_start=CountInfoPlayerStart()+CountInfoPlayerDeathmatch();
		int room=info_player_start-count;
		if(room<=0)
		{
			strcpy(szRejectReason,"server is full\n");
			RETURN_META_VALUE(MRES_SUPERCEDE, false);
		}
	}
	int i=ENTINDEX(pEntity);
	memset(&g_PlayerInfo[i],0,sizeof(player_extra_info_t));


	g_PlayerInfo[i].bInitHUD=false;
	g_PlayerInfo[i].damage=0;
	g_PlayerInfo[i].damage2enemy=0;
	g_PlayerInfo[i].teamnumber=NONE;
	cvar_update();

	RETURN_META_VALUE(MRES_IGNORED,META_RESULT_PREVIOUS);
}
void ClientDisconnect(edict_t *pEntity)
{
	// ALERT(at_console,"ClientDisconnect\n");
	int i=ENTINDEX(pEntity);
	memset(&g_PlayerInfo[i],0,sizeof(player_extra_info_t));
	g_PlayerInfo[i].bInitHUD=false;
	g_PlayerInfo[i].damage=0;
	g_PlayerInfo[i].damage2enemy=0;
	// if(!FNullEnt(FakePlayer[i]))REMOVE_ENTITY(FakePlayer[i]);
	RETURN_META(MRES_IGNORED);
}
void ClientCommand(edict_t *pEntity)
{
	// ALERT(at_console,"ClientCommand %s\n",pcmd);
	if(check_cmd(pEntity)) {
		RETURN_META(MRES_SUPERCEDE);
	}
	else {
		RETURN_META(MRES_IGNORED);
	}
}
/*void PlayerPreThink(edict_t *pEntity)
{
	// ALERT(at_console,"PlayerPreThink\n");
//	if(g_mod_type==CSTRIKE)CS_PlayerThink(pEntity);

	RETURN_META(MRES_IGNORED);
}*/

void StartFrame(void)
{
	// ALERT(at_console,"StartFrame\n");
	if(gpGlobals->deathmatch)
	{
		static float previous_time=1000.0;
		static float timer=0.0;
		// if a new map has started then(MUST BE FIRST IN StartFrame)...
		if((gpGlobals->time + 0.1)< previous_time)
		{
			int i;
			for(i=1; i<=MAX_PLAYERS; i++)
			{
				memset(&g_PlayerInfo[i],0,sizeof(player_extra_info_t));
				g_PlayerInfo[i].bInitHUD=false;
				g_PlayerInfo[i].damage=0;
				g_PlayerInfo[i].damage2enemy=0;
			}
			timer=SetTimer(1);
			if(g_mod_type==CSTRIKE)CS_StartFrame();
		}
		if(g_mod_type==CSTRIKE)CS_Frame();
		if(timer<=gpGlobals->time)
		{
			if(g_mod_type==CSTRIKE)CS_Update();
			timer=SetTimer(10);
		}
		previous_time=gpGlobals->time;
	}
	RETURN_META(MRES_IGNORED);
}

static DLL_FUNCTIONS gFunctionTable=
{
	NULL,//GameDLLInit, // pfnGameInit
	NULL,//DispatchSpawn, // pfnSpawn
	NULL, // pfnThink
	NULL, // pfnUse
	NULL, // pfnTouch
	NULL, // pfnBlocked
	DispatchKeyValue, // pfnKeyValue
	NULL, // pfnSave
	NULL, // pfnRestore
	NULL, // pfnSetAbsBox
	NULL, // pfnSaveWriteFields
	NULL, // pfnSaveReadFields
	NULL, // pfnSaveGlobalState
	NULL, // pfnRestoreGlobalState
	NULL, // pfnResetGlobalState
	ClientConnect, // pfnClientConnect
	ClientDisconnect, // pfnClientDisconnect
	NULL, // pfnClientKill
	NULL, // pfnClientPutInServer
	ClientCommand, // pfnClientCommand
	NULL, // pfnClientUserInfoChanged
	NULL, // pfnServerActivate
	NULL, // pfnServerDeactivate
	NULL,//PlayerPreThink, // pfnPlayerPreThink
	NULL, // pfnPlayerPostThink
	StartFrame, // pfnStartFrame
	NULL, // pfnParmsNewLevel
	NULL, // pfnParmsChangeLevel
	NULL, // pfnGetGameDescription
	NULL, // pfnPlayerCustomization
	NULL, // pfnSpectatorConnect
	NULL, // pfnSpectatorDisconnect
	NULL, // pfnSpectatorThink
	NULL, // pfnSys_Error
	NULL, // pfnPM_Move
	NULL, // pfnPM_Init
	NULL, // pfnPM_FindTextureType
	NULL, // pfnSetupVisibility
	NULL, // pfnUpdateClientData
	NULL,//AddToFullPack, // pfnAddToFullPack
	NULL, // pfnCreateBaseline
	NULL, // pfnRegisterEncoders
	NULL, // pfnGetWeaponData
	NULL, // pfnCmdStart
	NULL, // pfnCmdEnd
	NULL, // pfnConnectionlessPacket
	NULL, // pfnGetHullBounds
	NULL, // pfnCreateInstancedBaselines
	NULL, // pfnInconsistentFile
	NULL, // pfnAllowLagCompensation
};
C_DLLEXPORT int GetEntityAPI2(DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion)
{
	if(!pFunctionTable){
		UTIL_LogPrintf("GetEntityAPI2 called with null pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion!=INTERFACE_VERSION){
		UTIL_LogPrintf("GetEntityAPI2 version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
		//! Tell engine what version we had, so it can figure out who is out of date.
		*interfaceVersion=INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pFunctionTable, &gFunctionTable, sizeof(DLL_FUNCTIONS));
	return(TRUE);
}
