#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "sdk_util.h"
#include "cbase.h"
#include "const.h"
#include "weaponinfo.h"
#include "progdefs.h"
#include "scriplib.h"
#include "bmx_plugin.h"
#include "cstrike.h"

#include "item.h"
#include "usrmsg.h"
#include "playerbuy.h"
#include "moneymsg.h"

ammo_t ammos[]={
	{"ammo_338magnum",1,10,125},
	{"ammo_762nato",2,30,80},
	{"ammo_556natobox",3,30,60},
	{"ammo_556nato",4,30,60},
	{"ammo_buckshot",5,8,65},
	{"ammo_45acp",6,12,25},
	{"ammo_57mm",7,50,50},
	{"ammo_50ae",8,7,40},
	{"ammo_357sig",9,13,50},
	{"ammo_9mm",10,30,20},
	{NULL,0,0,0}
};
ammo_t *ammo_lookup(int id)
{
	for(ammo_t *ammox=ammos; ammox->Name; ammox++)
		if(ammox->iId==id)
			return ammox;
		return NULL;
}
weapon_t weapons[]={
	{"weapon_smokegrenade",13,1,3,3,9,24,1},
	{"weapon_hegrenade",12,1,3,1,4,24,1},
	{"weapon_flashbang",11,2,3,2,25,24,2},
	{"weapon_usp",6,48,1,4,16,0,12},
	{"weapon_glock18",10,90,1,2,17,0,20},
	{"weapon_deagle",8,35,1,1,26,0,7},
	{"weapon_p228",9,52,1,3,1,0,13},
	{"weapon_elite",10,120,1,5,10,0,30},
	{"weapon_fiveseven",7,100,1,6,11,0,20},
	{"weapon_xm1014",5,32,0,12,5,0,7},
	{"weapon_m3",5,32,0,5,21,0,8},
	{"weapon_ak47",2,90,0,1,28,0,30},
	{"weapon_sg552",4,90,0,10,27,0,30},
	{"weapon_m4a1",4,90,0,6,22,0,30},
	{"weapon_aug",4,90,0,14,8,0,30},
	{"weapon_scout",2,60,0,9,3,0,10},
	{"weapon_awp",1,30,0,2,18,0,10},
	{"weapon_g3sg1",2,40,0,3,24,0,20},
	{"weapon_sg550",4,90,0,16,13,0,30},
	{"weapon_mp5navy",10,120,0,7,19,0,30},
	{"weapon_tmp",10,120,0,11,23,0,30},
	{"weapon_p90",7,100,0,8,30,0,50},
	{"weapon_mac10",6,90,0,13,7,0,30},
	{"weapon_ump45",6,100,0,15,12,0,25},
	{"weapon_m249",3,200,0,4,20,0,100},
	{"weapon_c4",14,1,4,3,6,24,1},
	{"weapon_knife",-1,255,2,1,29,0,1},
	{NULL,0,0,0,0,0,0,0}
};
weapon_t *weapon_lookup(const char *Name)
{
	for(weapon_t *weapon=weapons; weapon->Name; weapon++)
		if(strcmp(weapon->Name,Name)==0)
			return weapon;
		return NULL;
}
weapon_t *weapon_lookup(int id)
{
	for(weapon_t *weapon=weapons; weapon->Name; weapon++)
		if(weapon->iId==id)
			return weapon;
		return NULL;
}
weapon_t *weapon_lookup(edict_t *pEdict, int iSlot)
{
	for(weapon_t *weapon=weapons; weapon->Name; weapon++)
		if(weapon->iSlot==iSlot &&(pEdict->v.weapons &(1<<weapon->iId)))
			return weapon;
		return NULL;
}
weapon_t *weapon_lookup(int mask, int iSlot)
{
	for(weapon_t *weapon=weapons; weapon->Name; weapon++)
		if(weapon->iSlot==iSlot &&(mask &(1<<weapon->iId)))
			return weapon;
		return NULL;
}
buyitem_t buyitems[]=
{
	{"weapon_usp",500,1,1,ALL,ALL,ALL},
	{"weapon_glock18",400,1,2,ALL,ALL,ALL},
	{"weapon_deagle",650,1,3,ALL,ALL,ALL},
	{"weapon_p228",600,1,4,ALL,ALL,ALL},
	{"weapon_elite",1000,1,5,TERRORIST,TERRORIST,TERRORIST},
	{"weapon_fiveseven",750,1,6,CT,CT,CT},
	{"weapon_m3",1700,2,1,NONE,ALL,ALL},
	{"weapon_xm1014",3000,2,2,NONE,ALL,ALL},
	{"weapon_mp5navy",1500,3,1,CT,ALL,ALL},
	{"weapon_tmp",1250,3,2,CT,CT,CT},
	{"weapon_p90",2350,3,3,CT,ALL,ALL},
	{"weapon_mac10",1400,3,4,TERRORIST,TERRORIST,TERRORIST},
	{"weapon_ump45",1700,3,5,ALL,ALL,ALL},
	{"weapon_ak47",2500,4,1,TERRORIST,TERRORIST,TERRORIST},
	{"weapon_sg552",3500,4,2,NONE,TERRORIST,TERRORIST},
	{"weapon_m4a1",3100,4,3,CT,CT,CT},
	{"weapon_aug",3500,4,4,CT,CT,CT},
	{"weapon_scout",2750,4,5,TERRORIST,ALL,ALL},
	{"weapon_awp",4750,4,6,TERRORIST,ALL,ALL},
	{"weapon_g3sg1",5000,4,7,ALL,ALL,ALL},
	{"weapon_sg550",4200,4,8,CT,CT,CT},
	{"weapon_m249",5750,5,1,CT,ALL,ALL},
	{"item_kevlar",650,8,1,ALL,ALL,ALL},
	{"item_assaultsuit",1000,8,2,ALL,ALL,ALL},
	{"weapon_flashbang",200,8,3,ALL,ALL,ALL},
	{"weapon_hegrenade",300,8,4,ALL,ALL,ALL},
	{"weapon_smokegrenade",300,8,5,ALL,ALL,ALL},
	{"item_thighpack",200,8,6,NONE,CT,NONE},
	{"nightvision",1250,8,7,ALL,ALL,ALL},
	{NULL,0,0,0,NONE,NONE,NONE}
};
buyitem_t *buyitem_lookup(int menu1, int menu2)
{
	for(buyitem_t *item=buyitems; item->name; item++)
		if(item->menu1==menu1 && item->menu2==menu2)
			return item;
		return NULL;
}
buyitem_t *buyitem_lookup(const char *name)
{
	for(buyitem_t *item=buyitems; item->name; item++)
		if(strcmp(item->name,name)==0)
			return item;
		return NULL;
}