#include "extdll.h"
#include <meta_api.h> // of course
#include "enginecallback.h"
#include "sdk_util.h"
#include "cbase.h"
#include "bmx_plugin.h"
#include "cstrike.h"
#include "scriplib.h"

#include "item.h"
#include "usrmsg.h"
#include "playerbuy.h"
#include "moneymsg.h"

CPlayerBuy pBuy[MAX_PLAYERS+1];
/////////////////////////////////////////////////////////////////////////////////////
//
//
//
CPlayerBuy::CPlayerBuy()
{
	reset_all();
}

void CPlayerBuy::reset_menu1()
{
	menuselect_1=-1;
}

void CPlayerBuy::reset_menu2()
{
	menuselect_2=-1;
}

void CPlayerBuy::reset_all()
{
	f_buy=false;
	menuselect_1=-1;
	menuselect_2=-1;
}

void CPlayerBuy::set_buy(int _id)
{
	reset_all();
	f_buy=true;
	my_id=_id;
	pEntity=INDEXENT(my_id);
	if(g_PlayerInfo[my_id].buyzone==false)
	{
		CantBuyHere(pEntity);
		reset_all();
		return;
	}
	else if(buytime<=gpGlobals->time)
	{
		CantBuyNow(pEntity);
		reset_all();
		return;
	}
}

int CPlayerBuy::set_menuselect(int x)
{
	if(f_buy==false)
		return 0;
	if(g_PlayerInfo[my_id].buyzone==false)
	{
		CantBuyHere(pEntity);
		reset_all();
		return 0;
	}
	else if(buytime<=gpGlobals->time)
	{
		CantBuyNow(pEntity);
		reset_all();
		return 0;
	}
	if(menuselect_1==-1)
	{
		menuselect_1=x;
		return 1;
	}
	else
	{
		menuselect_2=x;
		return 2;
	}
}

void CPlayerBuy::check(bool give)
{
	if(g_PlayerInfo[my_id].buyzone==false)
	{
		CantBuyHere(pEntity);
		reset_all();
		return;
	}
	else if(buytime<=gpGlobals->time)
	{
		CantBuyNow(pEntity);
		reset_all();
		return;
	}
	if(f_buy!=true || menuselect_1==-1)
		return;
	if(menuselect_1!=6 && menuselect_1!=7 && menuselect_2==-1)//Except BuPrimAmmo BuySecAmmo
		return;
	switch(menuselect_1){
	case 6: //Primary weapon ammo
		BuyPrimAmmo(false);
		break;
	case 7: //Secondary weapon ammo
		BuySecAmmo(false);
		break;
	default:
		GiveWeapons(give);
	}
	reset_all();
}
/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
//
// public
//
void CPlayerBuy::BuyPrimAmmo(bool one)
{
	if(g_map_type==KA_MAP||g_map_type==PA_MAP)
	{
		return;
	}
	if(buyammo1time >(gpGlobals->time + 10.0))
		buyammo1time=gpGlobals->time;
	if(buyammo1time>gpGlobals->time)
		return;
	buyammo1time=SetTimer(0.25);
	if(g_PlayerInfo[my_id].attrib==VIP&&strcmp(buyrestrict,"norestrict"))
	{
		ClientPrint(pEntity, HUD_PRINTCENTER, "#VIP_cant_buy");
		UTIL_ClearMenu(pEntity);
		return;
	}
	int id=g_PlayerInfo[my_id].primid;
	weapon_t *slotweap=NULL;
	if(pEntity->v.weapons &(1<<id))
	{
		slotweap=weapon_lookup(id);
	}
	if(slotweap&&slotweap->iSlot!=0)
	{
		slotweap=NULL;		
	}

	if(!slotweap)slotweap=weapon_lookup(pEntity, 0);
	int money=CalcMoney(my_id,0);
	if(slotweap&&slotweap->iAmmoType)
	{
		ammo_t *ammox=ammo_lookup(slotweap->iAmmoType);
		if(g_PlayerInfo[my_id].ammo[slotweap->iAmmoType]<0)g_PlayerInfo[my_id].ammo[slotweap->iAmmoType]=0;

		int ammo=slotweap->iMax - g_PlayerInfo[my_id].ammo[slotweap->iAmmoType];
		if(ammox&&ammox->Name&&money>=ammox->cost)
		{
			if(ammo>0)
			{
				for(;ammo>0;ammo-=ammox->iNum)
				{
					GiveNamedItem(pEntity, ammox->Name);
					g_PlayerInfo[my_id].ammo[slotweap->iAmmoType]+=ammox->iNum;
					money=CalcMoney(my_id, ammox->cost);
					if(one||money<ammox->cost)
					{
						break;
					}
				}
				mMSG.MoneyMsg(my_id);
				UTIL_ClearMenu(pEntity);
			}
			else
			{
				ClientPrint(pEntity, HUD_PRINTCENTER, "#Cannot_Carry_Anymore");
				UTIL_ClearMenu(pEntity);
				return;
			}
		}
	}
}
void CPlayerBuy::BuySecAmmo(bool one)
{
	if(g_map_type==KA_MAP||g_map_type==PA_MAP)
	{
		return;
	}
	if(buyammo2time >(gpGlobals->time + 10.0))
		buyammo2time=gpGlobals->time;
	if(buyammo2time>gpGlobals->time)
		return;
	buyammo2time=SetTimer(0.25);
	if(g_PlayerInfo[my_id].attrib==VIP&&strcmp(buyrestrict,"norestrict"))
	{
		ClientPrint(pEntity, HUD_PRINTCENTER, "#VIP_cant_buy");
		UTIL_ClearMenu(pEntity);
		return;
	}
	int id=g_PlayerInfo[my_id].secid;
	weapon_t *slotweap=NULL;
	if(pEntity->v.weapons &(1<<id))
	{
		slotweap=weapon_lookup(id);
	}
	if(slotweap&&slotweap->iSlot!=1)
	{
		slotweap=NULL;		
	}
	if(!slotweap)slotweap=weapon_lookup(pEntity, 1);
	int money=CalcMoney(my_id,0);
	if(slotweap&&slotweap->iAmmoType)
	{
		ammo_t *ammox=ammo_lookup(slotweap->iAmmoType);
		if(g_PlayerInfo[my_id].ammo[slotweap->iAmmoType]<0)g_PlayerInfo[my_id].ammo[slotweap->iAmmoType]=0;

		int ammo=slotweap->iMax - g_PlayerInfo[my_id].ammo[slotweap->iAmmoType];
		if(ammox&&ammox->Name&&money>=ammox->cost)
		{
			if(ammo>0)
			{
				for(;ammo>0;ammo-=ammox->iNum)
				{
					GiveNamedItem(pEntity, ammox->Name);
					g_PlayerInfo[my_id].ammo[slotweap->iAmmoType]+=ammox->iNum;
					money=CalcMoney(my_id, ammox->cost);
					if(one||money<ammox->cost)
					{
						break;
					}
				}
				mMSG.MoneyMsg(my_id);
				UTIL_ClearMenu(pEntity);
			}
			else
			{
				ClientPrint(pEntity, HUD_PRINTCENTER, "#Cannot_Carry_Anymore");
				UTIL_ClearMenu(pEntity);
				return;
			}
		}
	}
}
//////////////////////////////////////////////////////////////////
void CPlayerBuy::GiveWeapons(bool give)
{
	buyitem_t *item=buyitem_lookup(menuselect_1, menuselect_2);
	if(!item)
		return;
	if(!check_team(item)&&strcmp(buyrestrict,"norestrict"))
		return;
	weapon_t *weapon=weapon_lookup(item->name);
	if(weapon&&weapon->Name&&strstr(buyrestrict,weapon->Name))
	{
		CantBuyThis(pEntity);
		return;
	}
	int money=CalcMoney(my_id,0);
	if(money<item->cost)
	{
		NotEnoughMoney(pEntity);
		return;
	}
	/////////////////////////////////////////////////////////////////
	if(strcmp(item->name,"nightvision")==0)
	{
		if(g_PlayerInfo[my_id].nightvision)
		{
			return;
		}
		else
		{
			g_PlayerInfo[my_id].nightvision=true;
			g_PlayerInfo[my_id].nvgtoggle=true;
			UTIL_NVGToggle(pEntity);
		}
	}
	else
	{
		if(weapon&&weapon->iSlot==3)
		{
			if(g_PlayerInfo[my_id].ammo[weapon->iAmmoType]<0)g_PlayerInfo[my_id].ammo[weapon->iAmmoType]=0;
			int ammo=g_PlayerInfo[my_id].ammo[weapon->iAmmoType];
			if(ammo>=weapon->iMax||
				(weapon->iId==WEAPON_HEGRENADE&&pEntity->v.weapons &(1 << WEAPON_HEGRENADE))||
				(weapon->iId==WEAPON_SMOKEGRENADE&&pEntity->v.weapons &(1 << WEAPON_SMOKEGRENADE)))
			{
				ClientPrint(pEntity, HUD_PRINTCENTER, "#Cannot_Carry_Anymore");
				UTIL_ClearMenu(pEntity);
				return;
			}
		}
		else if(multiweapons==0&&weapon&&weapon->Name)
		{
			weapon_t *slotweap=weapon_lookup(pEntity, weapon->iSlot);
			if(slotweap&&slotweap->Name)
			{
				FakeClientCommand(pEntity, slotweap->Name);
				FakeClientCommand(pEntity, "drop",slotweap->Name, NULL);
			}
		}
		else if(strcmp(item->name,"item_kevlar")==0||strcmp(item->name,"item_assaultsuit")==0)
		{
			if(strcmp(item->name,"item_assaultsuit")==0&&g_PlayerInfo[my_id].armortype==0)
			{
				g_PlayerInfo[my_id].armortype=1;
			}
			else if(g_PlayerInfo[my_id].battery==100)
			{
				ClientPrint(pEntity, HUD_PRINTCENTER, "#Already_Have_One");
				UTIL_ClearMenu(pEntity);
				return;
			}
			g_PlayerInfo[my_id].battery=100;
		}
		else if(strcmp(item->name,"item_thighpack")==0)
		{
			if(g_PlayerInfo[my_id].defuser)
			{
				ClientPrint(pEntity, HUD_PRINTCENTER, "#Already_Have_One");
				UTIL_ClearMenu(pEntity);
				return;
			}
			g_PlayerInfo[my_id].defuser=true;
		}
		if(weapon&&weapon->iId)
		{
		//	g_PlayerInfo[my_id].weaponid=weapon->iId;
			if(weapon->iSlot==0)
				g_PlayerInfo[my_id].primid=weapon->iId;
			else if(weapon->iSlot==1)
				g_PlayerInfo[my_id].secid=weapon->iId;

		}
		if(give)
			GiveNamedItem(pEntity, item->name);
		UTIL_ClearMenu(pEntity);
	}
	CalcMoney(my_id, item->cost);
	mMSG.MoneyMsg(my_id);
}
int CPlayerBuy::get_cost()
{
	if(menuselect_2==-1)
		return 0;
	buyitem_t *item=buyitem_lookup(menuselect_1, menuselect_2);
	if(!item)
		return 0;
	if(!check_team(item))
		return 0;
	return item->cost;
}
int CPlayerBuy::get_slot()
{
	if(menuselect_2==-1)
		return -1;
	buyitem_t *item=buyitem_lookup(menuselect_1, menuselect_2);
	if(!item)
		return -1;
	weapon_t *weapon=weapon_lookup(item->name);
	if(weapon&&weapon->iSlot)
	{
		return weapon->iSlot;
	}
	return -1;
}
bool CPlayerBuy::check_team(buyitem_t *item)
{
	if(g_PlayerInfo[my_id].attrib==VIP)
	{
		ClientPrint(pEntity, HUD_PRINTCENTER, "#VIP_cant_buy");
		UTIL_ClearMenu(pEntity);
		return false;
	}
	switch(g_map_buying)
	{
	case 3:
		{
			CantBuyThis(pEntity);
			return false;
		}
	case 1:
		if(g_PlayerInfo[my_id].teamnumber==TERRORIST)
		{
			CantBuyThis(pEntity);
			return false;
		}
	case 2:
		if(g_PlayerInfo[my_id].teamnumber==CT)
		{
			CantBuyThis(pEntity);
			return false;
		}
	case 0:
		break;
	default:
		break;
	}
	if(g_map_type==AS_MAP)
	{
		switch(item->as)
		{
		case ALL:
			break;
		case NONE:
			{
				CantBuyThis(pEntity);
				return false;
			}
		default:
			if(g_PlayerInfo[my_id].teamnumber!=item->as)
			{
				CantBuyThis(pEntity);
				return false;
			}
		}
	}
	else if(g_map_type==DE_MAP)
	{
		switch(item->de)
		{
		case ALL:
			break;
		case NONE:
			{
				CantBuyThis(pEntity);
				return false;
			}
		default:
			if(g_PlayerInfo[my_id].teamnumber!=item->de)
			{
				CantBuyThis(pEntity);
				return false;
			}
		}
	}
	else if(g_map_type==KA_MAP||g_map_type==PA_MAP)
	{
		CantBuyThis(pEntity);
		return false;
	}
	else
	{
		switch(item->cs)
		{
		case ALL:
			break;
		case NONE:
			{
				CantBuyThis(pEntity);
				return false;
			}
		default:
			if(g_PlayerInfo[my_id].teamnumber!=item->cs)
			{
				CantBuyThis(pEntity);
				return false;
			}
		}
	}
	return true;
}
